function [prec,tpr, fpr, Acc, Sn, Fmeasure, auPR, AUC,Yr, prdY ]=crossKcon(Adj,sim_drug,sim_pro,protein_list,targetPPI_list,fold)
% this procedure is for PrePPItar
% Adj is adjacnet matrix with row as drug, column as PPItarget
% sim_drug is drug similarity matrix;
% sim_pro is protein similarity matrix;
% protein_list lists the all proteins' ID involing PPItargets;
% targetPPI_list list PPItarget involing proteins' ID; 
% fold is number of foldKcon cross-validation
[Ip,Jp]=find(Adj==1);
[Iu,Ju]=find(Adj==0);

p=randperm(length(Iu),length(Ip));

In=Iu(p);Jn=Ju(p);

I=[Ip;In]; J=[Jp;Jn];
Y=[ones(length(Ip),1);-ones(length(In),1)];
Yr=[];
prdY=[];

CV=cvpartition(Y,'k',fold);

for k=1:fold
    prob_value=[];
    trn_drug_list=I(CV.training(k));
    trn_PPI_list=J(CV.training(k));
    tst_drug_list=I(CV.test(k));
    tst_PPI_list=J(CV.test(k));
    Ytrn=Y(CV.training(k));
    Ytst=Y(CV.test(k));
    
    Krn=GetConvKrn(trn_drug_list,trn_PPI_list,sim_drug,sim_pro,protein_list,targetPPI_list);
    Ktrn=[(1:length(Ytrn))' Krn];
    Kst=GetConvKst(trn_drug_list,trn_PPI_list,tst_drug_list,tst_PPI_list,sim_drug,sim_pro,protein_list,targetPPI_list);
    Ktst=[(1:length(Ytst))' Kst];
    Yr=[Yr;Ytst];
    model=svmtrain(Ytrn,Ktrn,'-s 0 -t 4 -b 1 -c 10');
    [predict_label, accuracy, prob_values]=svmpredict(Ytst,Ktst, model,'-b 1');
    predictedY=prob_values(:,1);
    prdY=[prdY;predictedY];
    k
end

Yr(Yr==-1)=0;

[prec,tpr, fpr, auPR, pred_thresh] = prec_rec(prdY,Yr);

clear r;clear s;
for i=1:length(tpr)-1
r(i)=(fpr(i+1)-fpr(i))*tpr(i);
s(i)=0.5*(fpr(i+1)-fpr(i))*(tpr(i+1)-tpr(i));
end
AUC=sum(r)+sum(s);

P=length(find(Yr==1));
N=length(find(Yr==-1));
Sn=1-fpr;
Acc=(tpr*P+Sn*N)/(P+N);
Fmeasure=2*(tpr.*Sn)./(tpr+Sn);
